/*
 * Particle.cpp
 *
 *  Created on: 23.02.2010
 *      Author: eckhardw
 */

#include "Particle.h"

//log4cxx::LoggerPtr Particle::logger(log4cxx::Logger::getLogger("loggerParticle"));

Particle::Particle(int type_arg)
{
    m_type = type_arg;
    m_force = glm::dvec3(0.0);
    m_old_f = glm::dvec3(0.0);

    //LOG4CXX_TRACE(logger, "Particle generated!");
}

Particle::Particle(const Particle &other)
{
    m_pos = other.m_pos;
    m_velo = other.m_velo;
    m_force = other.m_force;
    m_old_f = other.m_old_f;
    m_type = other.m_type;
    m_id = other.m_id;

    //LOG4CXX_TRACE(logger, "Particle generated by copy!");
}

Particle::Particle(const glm::dvec3 &x_arg, const glm::dvec3 &v_arg, int type_arg, int id_arg)
        : m_pos(x_arg),
          m_velo(v_arg),
          m_force(0.0f), m_old_f(0.0f),
          m_type(type_arg),
          m_id(id_arg)
{
    //LOG4CXX_TRACE(logger, "Particle generated!");
}

// Constructor for Assignment 4.3
Particle::Particle(const glm::dvec3 &x_arg, const glm::dvec3 &v_arg, const glm::dvec3 &f_arg,
                   const glm::dvec3 &old_f_arg, int type_arg, int id_arg)
        : m_pos(x_arg),
          m_velo(v_arg),
          m_force(f_arg),
          m_old_f(old_f_arg),
          m_type(type_arg),
          m_id(id_arg)
{
    //LOG4CXX_TRACE(logger, "Particle generated from imported file!");
}

Particle::~Particle()
{
    //LOG4CXX_TRACE(logger, "Particle destructed!");
}


std::string Particle::toString()
{
    std::stringstream stream;
    stream << "Particle: X:" << glm::to_string(m_pos) << " v: " << glm::to_string(m_velo) << " f: "
           << glm::to_string(m_force)
           << " old_f: " << glm::to_string(m_old_f) << " type: " << m_type << " id: " << m_id;
    return stream.str();
}

bool Particle::operator==(Particle &other)
{
    return (m_pos == other.m_pos) && (m_velo == other.m_velo) && (m_force == other.m_force) &&
           (m_type == other.m_type) && (m_old_f == other.m_old_f) && (m_id == other.m_id);
}

/** Assignment 4.3: returns all particle properties in a single line*/
std::string Particle::toTidyString()
{

    // format: COORD    VELO    FORCE   old_F   TYPE    ID
    std::string returnval =
            std::to_string(m_pos[0]) + " " + std::to_string(m_pos[1]) + " " + std::to_string(m_pos[2]) + " \t\t" +
            std::to_string(m_velo[0]) + " " + std::to_string(m_velo[1]) + " " + std::to_string(m_velo[2]) + " \t\t" +
            std::to_string(m_force[0]) + " " + std::to_string(m_force[1]) + " " + std::to_string(m_force[2]) + " \t\t" +
            std::to_string(m_old_f[0]) + " " + std::to_string(m_old_f[1]) + " " + std::to_string(m_old_f[2]) + " \t\t" +
            std::to_string(m_type) + " \t\t" +
            std::to_string(m_id);

    return returnval;
}

std::ostream &operator<<(std::ostream &stream, Particle &p)
{
    stream << p.toString();
    return stream;
}
